Package com.saxonica.ee.validate

## Class CompactStringValue

- java.lang.Object
- - com.saxonica.ee.validate.CompactStringValue

- All Implemented Interfaces:
    `java.lang.Iterable<AtomicValue>`, `AtomicSequence`, `GroundedValue`, `Sequence`

      public class CompactStringValue
      extends java.lang.Object
      implements AtomicSequence

  A compact representation of an atomic xs:string value used in saved tables for key and keyref constraints, designed to economize on space.
  Since:
    9.6

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CompactStringValue​(java.lang.String content)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `effectiveBooleanValue()` | Get the effective boolean value of this sequence
    `java.lang.CharSequence` | `getCanonicalLexicalRepresentation()` | Get the canonical lexical representation as defined in XML Schema.
    `int` | `getLength()` | Get the length of the sequence
    `java.lang.Comparable<?>` | `getSchemaComparable()` | Get a Comparable value that implements the XML Schema ordering comparison semantics for this value.
    `java.lang.String` | `getStringValue()` | Get a string representation of the sequence.
    `java.lang.CharSequence` | `getStringValueCS()` | Get a string representation of the sequence.
    `StringValue` | `head()` | Get the first item in the sequence
    `AtomicValue` | `itemAt​(int n)` | Get the Nth item in the sequence, zero-based
    `AtomicIterator<StringValue>` | `iterate()` | Make an iterator over the items in the sequence
    `java.util.Iterator<AtomicValue>` | `iterator()` |
    `GroundedValue` | `reduce()` | Reduce the sequence to its simplest form.
    `GroundedValue` | `subsequence​(int start, int length)` | Get a subsequence of the value
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize, toShortString`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### CompactStringValue

          public CompactStringValue​(java.lang.String content)

  - ### Method Detail

    - #### head

          public StringValue head()

      Description copied from interface: `AtomicSequence`
      Get the first item in the sequence
      Specified by:
        `head` in interface `AtomicSequence`
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence, or null if the sequence is empty

    - #### iterate

          public AtomicIterator<StringValue> iterate()

      Description copied from interface: `AtomicSequence`
      Make an iterator over the items in the sequence
      Specified by:
        `iterate` in interface `AtomicSequence`
      Specified by:
        `iterate` in interface `GroundedValue`
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        an iterator over the items in the sequence

    - #### itemAt

          public AtomicValue itemAt​(int n)

      Description copied from interface: `AtomicSequence`
      Get the Nth item in the sequence, zero-based
      Specified by:
        `itemAt` in interface `AtomicSequence`
      Specified by:
        `itemAt` in interface `GroundedValue`
      Parameters:
        `n` - the index of the required item, with 0 representing the first item in the sequence
      Returns:
        the Nth item in the sequence, or null if the index is out of range

    - #### getLength

          public int getLength()

      Description copied from interface: `AtomicSequence`
      Get the length of the sequence
      Specified by:
        `getLength` in interface `AtomicSequence`
      Specified by:
        `getLength` in interface `GroundedValue`
      Returns:
        the number of items in the sequence

    - #### getCanonicalLexicalRepresentation

          public java.lang.CharSequence getCanonicalLexicalRepresentation()

      Description copied from interface: `AtomicSequence`
      Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules.
      Specified by:
        `getCanonicalLexicalRepresentation` in interface `AtomicSequence`
      Returns:
        the canonical lexical representation if defined in XML Schema; otherwise, the result of casting to string according to the XPath 2.0 rules

    - #### getSchemaComparable

          public java.lang.Comparable<?> getSchemaComparable()

      Description copied from interface: `AtomicSequence`
      Get a Comparable value that implements the XML Schema ordering comparison semantics for this value. The default implementation is written to compare sequences of atomic values. This method is overridden for AtomicValue and its subclasses.

      In the case of data types that are partially ordered, the returned Comparable extends the standard semantics of the compareTo() method by returning the value `SequenceTool.INDETERMINATE_ORDERING` when there is no defined order relationship between two given values.

      Specified by:
        `getSchemaComparable` in interface `AtomicSequence`
      Returns:
        a Comparable that follows XML Schema comparison rules

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Description copied from interface: `AtomicSequence`
      Get a string representation of the sequence. The is the space-separated concatenation of the result of casting each of the items in the sequence to xs:string
      Specified by:
        `getStringValueCS` in interface `AtomicSequence`
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Returns:
        a whitespace-separated concatenation of the string values of the items making up the sequence, as a CharSequence.

    - #### getStringValue

          public java.lang.String getStringValue()

      Description copied from interface: `AtomicSequence`
      Get a string representation of the sequence. The is the space-separated concatenation of the result of casting each of the items in the sequence to xs:string
      Specified by:
        `getStringValue` in interface `AtomicSequence`
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Returns:
        a whitespace-separated concatenation of the string values of the items making up the sequence, as a String.

    - #### subsequence

          public GroundedValue subsequence​(int start,
                                           int length)

      Description copied from interface: `GroundedValue`
      Get a subsequence of the value
      Specified by:
        `subsequence` in interface `GroundedValue`
      Parameters:
        `start` - the index of the first item to be included in the result, counting from zero. A negative value is taken as zero. If the value is beyond the end of the sequence, an empty sequence is returned
        `length` - the number of items to be included in the result. Specify Integer.MAX_VALUE to get the subsequence up to the end of the base sequence. If the value is negative, an empty sequence is returned. If the length goes off the end of the sequence, the result returns items up to the end of the sequence
      Returns:
        the required subsequence.

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()
                                        throws XPathException

      Description copied from interface: `GroundedValue`
      Get the effective boolean value of this sequence
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Returns:
        the effective boolean value
      Throws:
        `XPathException` - if the sequence has no effective boolean value (for example a sequence of two integers)

    - #### reduce

          public GroundedValue reduce()

      Description copied from interface: `GroundedValue`
      Reduce the sequence to its simplest form. If the value is an empty sequence, the result will be EmptySequence.getInstance(). If the value is a single atomic value, the result will be an instance of AtomicValue. If the value is a single item of any other kind, the result will be an instance of Item. Otherwise, the result will typically be unchanged.
      Specified by:
        `reduce` in interface `GroundedValue`
      Returns:
        the simplified sequence

    - #### iterator

          public java.util.Iterator<AtomicValue> iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable<AtomicValue>`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`